function Adm03000_ReNotasFiscais_Service(localStorageEngine, Adm03000_ReNotasFiscais_Repository) {
	var paramFilial;
	var paramNf;

	this.setParametersFilial = function() {
		var filial = arguments[0] || getLocalVar('CDFILIAL') || 'FILIAL_LOGADA',
		    filtroFilial = [
		    	{
					"name": "CDFILIAL",
					"operator": "=",
					"value": filial
				}
			];

		return Adm03000_ReNotasFiscais_Repository.parametersForFilial(filtroFilial).then(function(result) {
			var parametros = result.dataset.filial_logada;
			paramFilial = parametros[0];
			paramNf = parametros[1];

			// console.log(paramNf[0]);

			var params =[];
			params.push(this.checaAlmoxarifado());
			params.push(paramFilial.CDFILIAL);
			params.push(paramFilial.NMFILIAL);
			params.push(paramNf.DATARE);

			return params;
		}.bind(this));
	};

    this.allInvoicesImportedByXML = () => paramNf.IDNFGERADAVIAXML != 'N';

	this.getValueValidSoma = function(nameSomatorio) {
		if(nameSomatorio === 'NRCOUNTCGC') {
			return paramNf.NRCOUNTCGC;
		} else if(nameSomatorio === 'NRCOUNTEMIS') {
			return paramNf.NRCOUNTEMIS;
		} else if(nameSomatorio === 'VRTOTANOTA') {
			return paramNf.VRTOTANOTA;
		} else if(nameSomatorio === 'NRCOUNTNUM') {
			return paramNf.NRCOUNTNUM;
		}
	};

	this.setParamNota = function(cdfilial, cdalmoxarife, cdlocalestoq, datare) {
		if(paramFilial.IDUTILLCESTQ === 'N') {
			cdlocalestoq = ' ';
		}

		if(paramFilial.IDUTILALMOX === 'N') {
			cdalmoxarife = ' ';
		}

		var filtro = [
			{
				"name": "CDFILIAL",
				"operator": "=",
				"value": cdfilial
			},
			{
				"name": "DATARE",
				"operator": "=",
				"value": datare
			},
			{
				"name": "CDALMOXARIFE",
				"operator": "=",
				"value": cdalmoxarife
			},
			{
				"name": "CDLOCALESTOQ",
				"operator": "=",
				"value": cdlocalestoq
			}
		];

		return Adm03000_ReNotasFiscais_Repository.parametersForNotaFiscal(filtro).then(function(result) {
				var newParam = result.dataset.notafiscal_forAdm03000;
				paramNf = newParam[0] || {
                    IDNFGERADAVIAXML: null,
					NRCOUNTCGC: null,
					NRCOUNTEMIS: null,
					VRTOTANOTA: null,
					NRCOUNTNUM: null
				};
		});
	};

	this.checaAlmoxarifado = function() {
		if(paramFilial.IDUTILALMOX === 'S') {
			return true;
		} else {
			return false;
		}
	};

	this.checaUtilizaLocal = function() {
		if(paramFilial.IDUTILLCESTQ === 'S') {
			return true;
		} else {
			return false;
		}
	};

	this.checaIdconscgcre = function() {
		if(paramFilial.IDCONSCGCRE === 'S') {
			return true;
		} else {
			return false;
		}
	};

	this.checaIdconsemisre = function() {
		if(paramFilial.IDCONSEMISRE  === 'S') {
			return true;
		} else {
			return false;
		}
	};

	this.checaIdconstotare = function() {
		if(paramFilial.IDCONSTOTARE === 'S') {
			return true;
		} else {
			return false;
		}
	};

	this.checaIdconsnumere = function() {
		if(paramFilial.IDCONSNUMERE === 'S') {
			return true;
		} else {
			return false;
		}
	};

	this.checaNotaEmpty = function() {
		if(paramNf.NRCOUNTCGC !== null) {
			return false;
		}

		if(paramNf.NRCOUNTEMIS !== null) {
			return false;
		}

		if(paramNf.NRCOUNTNUM !== null) {
			return false;
		}

		if(paramNf.VRTOTANOTA !== null) {
			return false;
		}

		return true;
	};

	this.buidlFilter = function(row) {
		if(row.CDALMOXARIFE === null) {
			row.CDALMOXARIFE = "T";
		}

		if(row.CDLOCALESTOQ === null) {
			row.CDLOCALESTOQ = "T";
		}

		return Adm03000_ReNotasFiscais_Repository.geraRelatorio(row);
	};

	this.retornaOperadorLogado = function() {
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];

        return localStorageEngine.download("df#/crud/operador", filter);
    };

	this.getNrorg = function() {
		return this.retornaOperadorLogado().then(function(operador) {
			return operador[0].NRORG;
		});
	};
}

Configuration(function(ContextRegister) {
	ContextRegister.register('Adm03000_ReNotasFiscais_Service', Adm03000_ReNotasFiscais_Service);
});
